;Stockcar Scramble
;stockcar model comes from the Darkmatter CD

;Controls - Arrow Keys
;Number Keys 1-9 give different camera views
;Press R to reset

Global numcars=20,totlaps=10

numcars=Input("How many cars on track (default=20) ?")
If numcars=0 Then numcars=20
totlaps=Input("How many laps (default=10) ?")
If totlaps=0 Then totlaps=10


Graphics3D 640,480,16

Const GRAVITY#=-.015

Const BODY=1,WHEEL=2,SCENE=3,TARMAC=4,STRUCT=5
Const NOCOL=6,SIDE=7

Const tlev=1000,tdet=1000


Global wturn#=0,wrot#=0,playercar=1,started=0
Global startime=MilliSecs()+1000,change,onscene,targ=1
Global allcpu=0,racestart=0,accel#=0.5,level=1
Global vx1#,vx2#,vy1#,vy2#,vz1#,vz2#,carol#
Global carx#,cary#,carz#,carpi#,carya#,carro#
Global laptimer=MilliSecs(),bestlap=0,record=0
Global co_left,co_right,co_for,co_rev
Global newview=3,roadcam=0
Global yourplace,verx#,very#,verz#
Global sigrol#,sigyaw#,toggle=0
Global my_timer=CreateTimer(80)
Global ftime=MilliSecs(),snapview=0
Global wx#,wy#,wz#,xn#,yn#
Global colang#,carvel#,endrace=0
Global freeze=MilliSecs(),yonscene
Global respot,inair=0


If Not(FileType("stock/stockcar.bmp"))

jstock=LoadImage("stock/stockcar.jpg")
ok=SaveImage(jstock,"stock/stockcar.bmp")

EndIf

Dim laptime$(50)


Dim carcol(10,3)
Data 255,255,255
Data 255,0,0
Data 0,0,255
Data 128,64,0
Data 0,0,0
Data 0,255,255
Data 255,0,255
Data 255,128,0
Data 255,200,0
Data 0,255,0

For k=1 To 10
For l=1 To 3
Read carcol(k,l)
Next
Next

Dim camviews#(9,6)
Data 5,-12,0.1,0,0,1
Data 2.5,-6,0.2,0,0,1
Data 2,-4,0.4,0,0,0.2
Data 1,1,1,1,2,0.1
Data 0.2,3,1,0.2,4,0.1
Data 20,0,1,0,0,0.1
Data 200,0,1,0,0,0.1
Data 0,0,0,0,0,0.1
Data 1,5,1,1,-5,0.1

For kp=1 To 9
For kq=1 To 6
Read camviews#(kp,kq)
Next
Next

Global cam_view=1

Dim texco#(4)
Data 0,0.1,0.9,1
For aa=1 To 4
Read texco#(aa)
Next

Global font=LoadFont("helvetica",14,True)
Global font2=LoadFont("helvetica",30,True)



Global terr=LoadTerrain( "stuff/heightmap_256.jpg" )
ScaleEntity terr,tlev/TerrainSize(terr),tlev*0.07,tlev/TerrainSize(terr)
TerrainDetail terr,tdet,True
TerrainShading terr,True
PositionEntity terr,-500,0,-500
tex=LoadTexture( "stuff/terrain-1.jpg" )
ScaleTexture tex,50,50
EntityTexture terr,tex
EntityType terr,SCENE


If inair=1 Then HideEntity terr

makeskybox("skytex2/bluesea")


starts=LoadTexture("stuff/startsign.jpg")

Global stgate=CreateMesh()
msurf=CreateSurface(stgate)
EntityTexture stgate,starts

newrect(msurf,0.15,0.4,0,0.01,0.4,0,0.75,1,1,2,0)
newrect(msurf,0.85,0.4,0,0.01,0.4,0,0.75,1,1,2,0)
newrect(msurf,0.5,0.9,0,0.5,0.1,0,0,1,0.75,1,0)

AddVertex msurf,0.5,0.5,1

FitMesh stgate,-20,0,0,40,15,1
PositionEntity stgate,0,20,0
;EntityPickMode stgate,2

Global maskit=0




;-- create tree from which to copy during road creation--

tree=LoadTexture("stuff/palmtree.jpg",4)

SetBuffer TextureBuffer(tree)

LockBuffer GraphicsBuffer()

For xx=0 To TextureWidth(tree)-1
For yy=0 To TextureHeight(tree)-1

rst=ReadPixelFast(xx,yy)

If xx=0 And yy=0 Then maskit=rst

uu=rst
b=uu Mod 256
uu=uu/256
g=uu Mod 256
uu=uu/256
r=uu Mod 256


If r>g+50 Or r>b+50
WritePixelFast xx,yy,$00000000
;mask shades of pink
Else
WritePixelFast xx,yy,rst
EndIf

Next
Next


UnlockBuffer GraphicsBuffer()


SetBuffer BackBuffer()


Global palmtree=CreateMesh()

EntityTexture palmtree,tree
EntityType palmtree,STRUCT

psurf=CreateSurface(palmtree)

For vv=0 To 120 Step 60
newrect(psurf,0.5,0.5,0,0.5,0.5,0,0,1,1,1,vv)
;add triangles to tree
Next


FitMesh palmtree,-5,0,-5,10,15,10

HideEntity palmtree

;--end of tree creation--



watertex=LoadTexture("stuff/water.bmp")

;makeplane(2000,50,tex,-0.5,1)
makeplane(2000,20,watertex,5,1)

piltex=LoadTexture("stuff/nat030.bmp")
ScaleTexture piltex,0.5,0.1

Global pillar=CreateCube()
FitMesh pillar,-5,0,-5,10,50,10
EntityType pillar,STRUCT
EntityTexture pillar,piltex
PositionEntity pillar,-70,TerrainY(terr,0,0,0)-5,50
EntityPickMode pillar,2
HideEntity pillar

Global spoke=LoadTexture("stuff/spoke2.bmp")

Type vehic
Field car,num,speed#,prev_x#,prev_y#,prev_z#
Field wturn#,wrot#,onground,forward#
Field wheels[4]
Field onpiece,reverse,accel#,recover
Field update,ahead,rubble,onscene
Field place,lap,maintain,lockout
Field notice#,losespeed,spturn#
Field transx#,transy#,transz#,fromcent#
Field pivot[3]
Field see,dropping,sunk
Field centpivot,offroad
End Type



Dim weely#(4)

Global roadpivot=CreatePivot()


;Global car=LoadMesh( "car.x" )
Global car=LoadMesh("stock/high.3ds")
ScaleMesh car,1,1,-1
FlipMesh car
FitMesh car,-1.5,-1.2,-3,3,2.4,6
EntityBox car,-2,-1,-4,4,2,8
EntityRadius car,1
PositionEntity car,0,100,0
EntityShininess car,1
EntityType car,BODY
HideEntity car



Global rrr=CountSurfaces(car)
ttt=GetSurface(car,1)
Global sss=CountTriangles(ttt)


Global whel=CreateCylinder(8,True)
EntityTexture whel,spoke
ScaleEntity whel,.5,.2,.5
EntityRadius whel,.5
HideEntity whel

Global wheels[4]



Global road=CreateMesh()
EntityType road,TARMAC
Global surface=CreateSurface(road)
Global track=LoadTexture("stuff/tunnel_road.jpg")
EntityTexture road,track


Global wallbar=LoadTexture("stuff/wallbar.bmp",4)

Global wall1=CreateMesh() ;wall on left of road
EntityType wall1,STRUCT
Global w1surf=CreateSurface(wall1)
EntityTexture wall1,wallbar

Global wall2=CreateMesh() ;wall on right of road
EntityType wall2,STRUCT
Global w2surf=CreateSurface(wall2)
EntityTexture wall2,wallbar




Global newroad=MilliSecs()
Global roady#=0,gmode=0,rdx#=0.1,count,d_ang#,ryc#,obst

;PositionEntity road,125,0.1,37

createroad("stuff/trackdata001.dat")

createcars(1)


light=CreateLight()
TurnEntity light,45,45,0

Global target

For hcar.vehic = Each vehic

If hcar\num=playercar
target=CreatePivot( hcar\car )
PositionEntity target,0,camviews#(cam_view,1),camviews#(cam_view,2)
EntityType target,NOCOL

EndIf

Next

Global camera=CreateCamera()
CameraRange camera,0.2,1000
CameraClsColor camera,75,150,255
;CameraClsColor camera,128,255,255
;CameraClsMode camera,0,1

Global camshadow=CreatePivot(camera)

For ka.vehic = Each vehic
ka\speed#=0
ka\prev_x#=EntityX( ka\car )
ka\prev_y#=EntityY( ka\car )
ka\prev_z#=EntityZ( ka\car )
Next

Global x_vel#=0,y_vel#=0,z_vel#=0,incols

UpdateWorld()

docollisions()

Global frams,frate=MilliSecs(),tframs

AmbientLight 192,192,192

While Not KeyHit(1)

If incols>0 Then incols=incols+1

If racestart=0 And incols=3
docollisions()
incols=0
EndIf

If KeyHit(19)
racestart=0
allcpu=0
createcars(0)
EndIf

toggle=toggle+1
If toggle=2 Then toggle=0


If KeyHit(31) Then savescreenshot()

	frams=frams+1
	
	If MilliSecs()-frate>1000
	frate=frate+1000
	tframs=frams
	frams=0
	EndIf


	;change=0
	;If KeyHit(16) Then playercar=playercar+1:change=1
	;If KeyHit(30) Then playercar=playercar-1:change=1
	;If playercar=numcars+1 Then playercar=1
	;If playercar=0 Then playercar=numcars
	
		
	For gcar.vehic = Each vehic
		
	onroof=1
	oturn#=wturn#
	
	
	If Abs(EntityRoll(gcar\car))<60 And Abs(EntityPitch(gcar\car))<60 Then onroof=0
		
	If MilliSecs()-gcar\recover>1000 And racestart=1
	
	aaa=1
	If aaa=1
	
	ResetEntity gcar\car
	For mb=1 To 4
	ResetEntity gcar\wheels[mb]
	Next
	
		gcar\recover=MilliSecs()
		;gcar\speed=0
		
	RotateEntity gcar\car,0,0,0
	
	cartowheels(gcar.vehic)
	
	repwheels(gcar.vehic)
	
	followroad(gcar.vehic,2)
	
	If racestart=0 Then upt=5 Else upt=5	
	TranslateEntity gcar\car,0,upt,0
	
	gcar\prev_x=EntityX(gcar\car)
	gcar\prev_y=EntityY(gcar\car)
	gcar\prev_z=EntityZ(gcar\car)
	
	gcar\maintain=10

	EndIf
	EndIf
	
		
	
	onscene=0
	
	If EntityCollided( gcar\car,SCENE ) Then onscene=1
	If EntityCollided( gcar\car,TARMAC) Then onscene=2
	
	If gcar\fromcent#<=10 Then gcar\offroad=MilliSecs()
	
	If EntityCollided(gcar\centpivot,SIDE)
	If gcar\fromcent#>0 Then xdd#=-1 Else xdd#=1
	MoveEntity gcar\car,xdd#,0,0
	gcar\speed=gcar\speed*0.99
	gcar\lockout=1
	EndIf
	
	
	If onscene>0 Then gcar\dropping=0
	If gcar\dropping=1 Then TranslateEntity gcar\car,0,-1,0	
		
	If onroof=0 And gcar\maintain=0 Then cartowheels(gcar.vehic)
	
	If gcar\maintain>0
	gcar\maintain=gcar\maintain-1
	For uu=1 To 4
	ResetEntity gcar\wheels[uu]
	Next
	
	EndIf
	
	;calculate car velocities	
	cx#=EntityX( gcar\car ):x_vel=cx-gcar\prev_x:gcar\prev_x=cx
	cy#=EntityY( gcar\car ):y_vel=cy-gcar\prev_y:gcar\prev_y=cy
	cz#=EntityZ( gcar\car ):z_vel=cz-gcar\prev_z:gcar\prev_z=cz
	
	
	If gcar\lockout>0 Or gcar\dropping=1
	;PositionEntity gcar\car,cx#,TerrainY(terr,cx#,cy#,cz#),cz#
	x_vel=0
	y_vel=0
	z_vel=0
	gcar\lockout=gcar\lockout-1	
	EndIf
	
	
	carvel#=(x_vel^2+y_vel^2+z_vel^2)^0.5
	
	
	If EntityCollided(gcar\car,struct)
	ResetEntity gcar\car
	If Abs(carvel#)<Abs(gcar\speed) Then gcar\speed=carvel#
	gcar\speed=gcar\speed*0.99
	
	Else
	
	EndIf
		
		
	
	resp#=(carvel#+0.1)/(Abs(gcar\speed#)+0.1)

	
	If onroof=0	;And carstuck=0 And highest-lowest#<2
	If resp#>0.5 Or carvel#<0.2 Or gcar\speed<0.2	
	gcar\recover=MilliSecs()	
	EndIf	
	EndIf
	
	If EntityY(gcar\car)>0 Then gcar\sunk=MilliSecs()
	
	If onscene>0 And gcar\reverse=0
	If gcar\speed#>carvel#*5 And gcar\speed#>.5
	If gcar\num<>playercar Or allcpu=1 Then gcar\reverse=100
	EndIf
	EndIf
	
	If gcar\reverse>0
	If gcar\num<>playercar Or allcpu=1
	gcar\reverse=gcar\reverse-2
	If onscene>0 And gcar\reverse>50
	If gcar\speed>0 Then gcar\speed=0
	gcar\speed=gcar\speed-.02
	
	EndIf
	EndIf
	EndIf
	
		
	If onscene>0 And MilliSecs()-gcar\onscene>500
	gcar\transx#=gcar\transx#+x_vel*1
	gcar\transy#=-1
	gcar\transz#=gcar\transz#+z_vel*1
	
	EndIf
	
	If onscene>0 Then gcar\onscene=MilliSecs()
		
	;gcar\speed=gcar\speed+(carvel#-gcar\speed)*0.05
	;carvel#=5	
	repwheels(gcar.vehic)


	;move car
	co_left=0:co_right=0:co_for=0:co_rev=0
	
	If onroof=0 Then followroad(gcar.vehic,2-racestart)
	
	
	If gcar\num=playercar
	
	carx#=EntityX(gcar\car)
	cary#=EntityY(gcar\car)
	carz#=EntityZ(gcar\car)
	carpi#=EntityPitch(gcar\car)
	carya#=EntityYaw(gcar\car)
	carro#=EntityRoll(gcar\car)
	
	roadcam=((gcar\onpiece+10)/20)*20
	snapview=0
	
	For views=1 To 9
	fix=0
	If KeyHit(views+1) Then fix=1
	If cam_view<>newview And newview=views Then fix=1
	
	If fix=1
	snapview=1
	cam_view=views
	newview=views
	PositionEntity gcar\ahead,0,camviews#(views,4),camviews#(views,5)
		
	
	EndIf
	
	Next
	
	;If allcpu=1 Then racestart=1
	
	If allcpu=0
	If KeyDown(203) Then co_left=1
	If KeyDown(205) Then co_right=1
	If KeyDown(200) Then co_for=1
	If KeyDown(208) Then co_rev=1
	EndIf
	
	EndIf
	

	urate#=(Abs(gcar\speed)^0.5)*0.05
	If onscene=1 Then urate#=urate#*2
	
	If co_left=1
	gcar\wturn#=gcar\wturn#+3
	gcar\spturn#=(gcar\spturn#*1)+urate#
	EndIf
	
	If co_right=1
	gcar\wturn#=gcar\wturn#-3
	gcar\spturn#=(gcar\spturn#*1)-urate#
	EndIf
	
	TurnEntity gcar\car,0,gcar\spturn#,0
	
	gcar\spturn#=gcar\spturn#*0.95	
	gcar\wturn#=gcar\wturn#*0.9
		
	
	For ii=1 To 4
	turn#=gcar\wturn#
	If ii=3 Or ii=4 Then turn#=0
	
	RotateEntity gcar\wheels[ii],gcar\wrot#,turn#,90
	Next
	
	
	
	pre_ground=gcar\onground
	gcar\onground=onscene
	If pre_ground=0 And gcar\onground=1 And racestart=0 Then MoveEntity gcar\car,0.01,0.01,0.01
		
	If onscene>0
	gcar\losespeed=MilliSecs()
	EndIf
	
	
	
	If onscene>0
	
		;If gcar\num=playercar
	
		If co_for=1
		If racestart=0 Then laptimer=MilliSecs()
		racestart=1
			gcar\speed=gcar\speed+gcar\accel#*accel#
			;If gcar\speed>.7 Then gcar\speed=.7
		Else If co_rev=1
			If gcar\speed>0 Then rev#=.005 Else rev#=.0025*accel# 
			gcar\speed=gcar\speed-rev#
			;If gcar\speed<-.4 Then gcar\speed=-.4
		Else
		
		EndIf
		;MoveEntity gcar\car,0,0,gcar\speed
			
		
		If onscene=2 Then spless#=0.995+(gcar\speed*0.001)
		If onscene=1 Then spless#=0.98
		
		spless#=1-(1-spless#)*accel#
		
		gcar\speed=gcar\speed*spless#
		If onroof=0 Then MoveEntity gcar\car,0,0,gcar\speed
		
				
		If onscene>0 And onroof=1
		
		gi#=EntityPitch(gcar\car)
		pturn#=0:rturn#=0
		If gi#>5 Then pturn#=(gi#)*0.5
		If gi#<-5 Then pturn#=(gi#)*0.5
		
		gj#=EntityRoll(gcar\car)
		If gj#>0 And gj#<175 Then rturn#=(180-gj#)*0.05
		If gj#<0 And gj#>-175 Then rturn#=(-180-gj#)*0.05
				
		TurnEntity gcar\car,pturn#,0,rturn#
				
		EndIf
		
		
		pp#=EntityPitch(gcar\car)
		rr#=EntityRoll(gcar\car)
		
		If pp#>90 Then pp#=180-pp#
		If pp#<-90 Then pp#=-180-pp#
		If rr#>90 Then rr#=180-rr#
		If rr#<-90 Then rr#=-180-rr#
		
		If onscene=1 Then factr#=0.5
		If onscene=2 Then factr#=0.2
		If racestart=0 Or gcar\speed=0 Then factr#=0
		
		dfa#=(1-Cos(pp#))*Sgn(pp#)*factr#
		dfb#=(1-Cos(rr#))*Sgn(rr#)*factr#
		
		If Abs(dfa#)<0.01 Then dfa#=0
		If Abs(dfb#)<0.01 Then dfb#=0
				
		MoveEntity gcar\car,dfb#*GRAVITY#*100,0,-dfa#*GRAVITY#*200
		
		gcar\speed=gcar\speed-dfa#*GRAVITY#*5*gcar\speed
			
	
		gcar\wrot#=gcar\wrot#+gcar\speed*50	
		
		TranslateEntity gcar\car,0,GRAVITY,0
	Else
	
		gcar\wrot#=gcar\wrot#+gcar\speed*25
	
			
		TranslateEntity gcar\car,x_vel,y_vel+GRAVITY,z_vel
		If EntityY(gcar\car)<-10
		TranslateEntity gcar\car,0,-10-EntityY(gcar\car),0		
		EndIf
		
		
	EndIf
	
	
	
	
	;--start of camera operation--
	

	If gcar\num=playercar
		
	
	du#=EntityY(target,True)-EntityY(gcar\car,True)
	
		dx#=EntityX( target,True )-EntityX( camera )
		dy#=EntityY( target,True )-EntityY( camera )
		dz#=EntityZ( target,True )-EntityZ( camera )
		
		dcc#=camviews#(cam_view,3)
		If snapview=1 Then dcc#=1:snapview=0
		
		TranslateEntity camera,dx*dcc#,dy*dcc#,dz*dcc#
		xspeed#=(dx#^2+dy#^2+dz#^2)^0.5
		
		PointEntity camshadow,gcar\ahead
	;TurnEntity camshadow,0,EntityYaw(gcar\car)-EntityYaw(camshadow),0,True
	
	EndIf
	
		
	Next
	
	
		
	If cam_view<6 Or cam_view>7
	
	
	dpitch#=EntityPitch(camshadow,True)-EntityPitch(camera)
	dyaw#=EntityYaw(camshadow,True)-EntityYaw(camera)
	droll#=EntityRoll(camshadow,True)-EntityRoll(camera)
	
	If dpitch#>180 Then dpitch#=dpitch#-360
	If dpitch#<-180 Then dpitch#=dpitch#+360
	If dyaw#>180 Then dyaw#=dyaw#-360
	If dyaw#<-180 Then dyaw#=dyaw#+360
	If droll#>180 Then droll#=droll#-360
	If droll#<-180 Then droll#=droll#+360

	drate#=camviews#(cam_view,6)
	If snapview=1 Then drate#=1
	;If cam_view=6 Then droll#=carol#-EntityRoll(camera)
	
	TurnEntity camera,dpitch#*drate#,dyaw#*drate#,droll#*drate#
	
	EndIf
	
	
	If cam_view=6
	PositionEntity camera,carx#,cary#+50,carz#
	RotateEntity camera,90,carya#,0
	EndIf
	
	If cam_view=7	
	PositionEntity camera,-100,300,0
	RotateEntity camera,90,0,0 	
	EndIf
	
	If cam_view=8
	findverts(roadcam)
	PositionEntity camera,(vx1#+vx2#)/2,(vy1#+vy2#)/2+3,(vz1#+vz2#)/2,True
	EndIf
	
	;--end of camera operation--
	
	
	
		
	For gcar.vehic=Each vehic
	
	onscene=0
	
	If EntityCollided( gcar\car,SCENE ) Then onscene=1
	If EntityCollided( gcar\car,TARMAC) Then onscene=2
	
	If gcar\num=playercar Then yonscene=onscene

	
	If racestart=1 Then keepaway(gcar.vehic)
	
	If endrace=0
	
	newplace=1
	
	For icar.vehic=Each vehic
	add=0
	If icar\lap>gcar\lap Then add=1
	If icar\lap=gcar\lap
	If icar\onpiece>gcar\onpiece Then add=1
	If icar\onpiece=gcar\onpiece And icar\num<gcar\num Then add=1
	EndIf
	
	newplace=newplace+add
	
	Next
	
	gcar\place=newplace
	
	EndIf
	
	TranslateEntity gcar\car,gcar\transx#,gcar\transy#,gcar\transz#
	dec#=0.95
	If onscene=0 Then dec#=0.1
	
	gcar\transx#=gcar\transx#*dec#
	gcar\transy#=gcar\transy#*dec#
	gcar\transz#=gcar\transz#*dec#
		
	Next
	
	started=1
	
	theight#=TerrainY(terr,EntityX(camera),EntityY(camera),EntityZ(camera))+2
	If EntityY(camera)<10 Then theight#=10
	
	If theight#>EntityY(camera)
	If yonscene>0 Or theight#=10
	TranslateEntity camera,0,theight#-EntityY(camera),0
	EndIf
	EndIf
	
	If toggle=1
	UpdateWorld
	RenderWorld
	EndIf
	
	For gcar.vehic = Each vehic
	If gcar\num=playercar	
	
	If change=1
	EntityParent target,gcar\car
	PositionEntity target,0,camviews#(cam_view,1),camviews#(cam_view,2)
	EndIf
	
	yyy#=EntityY(target,True)-TerrainY(terr,EntityX(target,True),EntityY(target,True),EntityZ(target,True))
	;If Abs(EntityYaw(camera))<90 Then PositionEntity target,0,5,-12
	;If EntityPitch(camera)<0 And onroof=1 Then targ=-targ
	If yyy#<0 And onscene>0 Then targ=-targ
	
	
	PositionEntity target,0,targ*camviews#(cam_view,1),camviews#(cam_view,2)
	debugtext(gcar.vehic)
	
	screendata(gcar.vehic)	
	
	EndIf
	Next
	
	
	WaitTimer my_timer	
	If toggle=1
	Flip	
	Cls
	EndIf
		
	ftime=MilliSecs()
	
	If allcpu=1 Then racestart=1
	
Wend

End

Function cartowheels(gcar.vehic)

;align car to wheels

	zx#=(EntityX( gcar\wheels[2],True )+EntityX( gcar\wheels[4],True ))/2
	zx=zx-(EntityX( gcar\wheels[1],True )+EntityX( gcar\wheels[3],True ))/2
	zy#=(EntityY( gcar\wheels[2],True )+EntityY( gcar\wheels[4],True ))/2
	zy=zy-(EntityY( gcar\wheels[1],True )+EntityY( gcar\wheels[3],True ))/2
	zz#=(EntityZ( gcar\wheels[2],True )+EntityZ( gcar\wheels[4],True ))/2
	zz=zz-(EntityZ( gcar\wheels[1],True )+EntityZ( gcar\wheels[3],True ))/2
	AlignToVector gcar\car,zx,zy,zz,1,0.1
	
	zx#=(EntityX( gcar\wheels[1],True )+EntityX( gcar\wheels[2],True ))/2
	zx=zx-(EntityX( gcar\wheels[3],True )+EntityX( gcar\wheels[4],True ))/2
	zy#=(EntityY( gcar\wheels[1],True )+EntityY( gcar\wheels[2],True ))/2
	zy=zy-(EntityY( gcar\wheels[3],True )+EntityY( gcar\wheels[4],True ))/2
	zz#=(EntityZ( gcar\wheels[1],True )+EntityZ( gcar\wheels[2],True ))/2
	zz=zz-(EntityZ( gcar\wheels[3],True )+EntityZ( gcar\wheels[4],True ))/2
	AlignToVector gcar\car,zx,zy,zz,3,0.1
	
	
	cnt=0
	
	If onscene>0
	
	For iu=1 To -1 Step -2
	For iv=-1 To 1 Step 2
	
	cnt=cnt+1
	
	kga#=(EntityX(gcar\wheels[cnt])-iv*1.7)*iv
	kgb#=(EntityY(gcar\wheels[cnt])+1.2)*-1
	kgc#=(EntityZ(gcar\wheels[cnt])-iu*2)*iu
	
	kdiff#=(kga#^2+kgb#^2+kgc#^2)^0.5
	If kdiff#>3 Then ResetEntity gcar\wheels[cnt]
	
	If kga#<0 Then kga#=0
	If kgb#<0 Then kgb#=0
	If kgc#<0 Then kgc#=0
	
	MoveEntity gcar\car,kga#*iv,kgb#*-1,kgc#*iu
	
		
	Next
	Next
	
	EndIf
	
End Function


Function repwheels(gcar.vehic)

;resposition wheels
	cnt=1
	For z#=1.7 To -1.7 Step -3.4
	For x#=-1.5 To 1.5 Step 3				
		PositionEntity gcar\wheels[cnt],x#,-1,z#
		cnt=cnt+1
	Next
	Next
	
End Function

Function createcars(full)

bcc=CountVertices(surface)

tracko=(bcc/8)-2
tks=1
lapon=0

If full=0 Then ClearCollisions()

For nn=1 To numcars

If full=0

For wcar.vehic=Each vehic
If wcar\num=nn
vcar.vehic=wcar.vehic
EndIf

Next


EndIf


If full=1

vcar.vehic = New vehic

vcar\car=CopyEntity(car)


cnt=1
For z=1.5 To -1.5 Step -3
For x=-1.5 To 1.5 Step 3
			
	vcar\wheels[cnt]=CopyEntity(whel,vcar\car)
	;EntityParent vcar\wheels[cnt],vcar\car
	
	PositionEntity vcar\wheels[cnt],x,0,z
	
	TurnEntity vcar\wheels[cnt],0,0,90
	
	EntityType vcar\wheels[cnt],WHEEL
	
		
	cnt=cnt+1
Next
Next


For kd=1 To 3
vcar\pivot[kd]=CreatePivot(vcar\car)
PositionEntity vcar\pivot[kd],0,0,3-kd*1.5
Next

vcar\centpivot=CreatePivot(vcar\car)
PositionEntity vcar\centpivot,0,0,0
EntityRadius vcar\centpivot,3
EntityType vcar\centpivot,BODY

For ii=1 To 4
axle=CreateCube(vcar\wheels[ii])

If ii=2 Or ii=4 Then disp=1.5 Else disp=-1.5

EntityColor axle,0,0,0
ScaleEntity axle,0.2,2,0.2
PositionEntity axle,0,disp,0

Next

vcar\ahead=CreatePivot(vcar\car)
PositionEntity vcar\ahead,0,0,0

;gcirc=CreateSphere(8,vcar\ahead)


EndIf

vcar\num=nn
vcar\place=nn
vcar\onground=0
vcar\forward#=0
vcar\lockout=1
vcar\notice#=0
vcar\spturn#=0
vcar\fromcent#=0

vcar\onpiece=tracko*2
vcar\maintain=0
vcar\rubble=MilliSecs()
vcar\transx#=0
vcar\transy#=0
vcar\transz#=0
vcar\lap=lapon
vcar\speed=0
vcar\dropping=1


leftx#=VertexX(surface,tracko*8-3)
lefty#=VertexY(surface,tracko*8-3)
leftz#=VertexZ(surface,tracko*8-3)

rightx#=VertexX(surface,tracko*8-2)
righty#=VertexY(surface,tracko*8-2)
rightz#=VertexZ(surface,tracko*8-2)

posx#=(leftx#*(3-tks)+rightx#*tks)/3
posy#=(lefty#*(3-tks)+righty#*tks)/3
posz#=(leftz#*(3-tks)+rightz#*tks)/3

RotateEntity vcar\car,0,0,0

PositionEntity vcar\car,posx#,TerrainY(terr,posx#,posy#,posz#)+10,posz#

tks=tks+1
If tks=3 Then tks=1:tracko=tracko+2
If tracko>(bcc/8) Then tracko=tracko-bcc/8:lapon=lapon+1


ds=(vcar\num Mod 10)
If ds=0 Then ds=10
EntityColor vcar\car,carcol(ds,1),carcol(ds,2),carcol(ds,3)

Next

If full=0 Then incols=1
freeze=MilliSecs()

End Function


Function createroad(trackname$)

sev=OpenFile(trackname$)
If sev<>0

totverts=ReadInt(sev)


For index=0 To totverts-1

ovx#=verx#
ovy#=very#
ovz#=verz#

verx#=ReadInt(sev)
very#=ReadInt(sev)
verz#=ReadInt(sev)

If index=2
PositionEntity stgate,(verx#+ovx#)/2,(very#+ovy#)/2-5,(verz#+ovz#)/2
sigrol#=ASin((very#-ovy#)/20)*Sgn(very#-ovy#)
sigyaw#=-calc_ang#(verx#-ovx#,verz#-ovz#,0)

RotateEntity stgate,0,90-sigyaw#,0
EndIf

AddVertex surface,verx#,very#,verz#,texco#((index Mod 4)+1),roady#

If (index Mod 8)<=3 Then bartex=0 Else bartex=1

If (index Mod 4)=0
;add to left wall
AddVertex w1surf,verx#,very#,verz#,bartex,0
AddVertex w1surf,verx#,very#+5,verz#,bartex,1
EndIf

If (index Mod 4)=3
;add to right wall
AddVertex w2surf,verx#,very#,verz#,bartex,0
AddVertex w2surf,verx#,very#+5,verz#,bartex,1
EndIf



If index>3

If (index Mod 4)=3

	count=CountVertices(surface)

	;new section of road
	newtri(surface,count,8,4,7,inair)
	newtri(surface,count,7,4,3,inair)
	newtri(surface,count,7,3,6,inair)
	newtri(surface,count,6,3,2,inair)
	newtri(surface,count,6,2,5,inair)
	newtri(surface,count,5,2,1,inair)
	
wcount=CountVertices(w2surf)
;add to right wall
newtri(w2surf,wcount,4,2,3,1)
newtri(w2surf,wcount,3,2,1,1)

If (index Mod 12)=7

vlx#=VertexX(surface,count-4)
vly#=VertexY(surface,count-4)
vlz#=VertexZ(surface,count-4)

;new tree on left of road
vpx#=vlx#-(verx#-vlx#)*0.3
vpz#=vlz#-(verz#-vlz#)*0.3
palm=CopyEntity(palmtree)
PositionEntity palm,vpx#,TerrainY(terr,vpx#,0,vpz#),vpz#

;new tree on right of road
vpx#=verx#+(verx#-vlx#)*0.3
vpz#=verz#+(verz#-vlz#)*0.3
palm=CopyEntity(palmtree)
PositionEntity palm,vpx#,TerrainY(terr,vpx#,0,vpz#),vpz#

EndIf

EndIf

If (index Mod 4)=0

wcount=CountVertices(w1surf)
;add to left wall
newtri(w1surf,wcount,4,2,3,1)
newtri(w1surf,wcount,3,2,1,1)

EndIf	
	
EndIf

If (index Mod 4)=3

roady#=roady#+rdx#
	If roady#=1 Then rdx#=-0.1
	If roady#=0 Then rdx#=0.1

If index=totverts-5
If roady#<0.5 Then roady#=roady#+0.5
If roady#>=0.5 Then roady#=roady#-0.5
EndIf


EndIf


Next


CloseFile sev
EndIf

End Function



Function newtri(surf,total,one,two,three,backon)
AddTriangle(surf,total-one,total-two,total-three)
If backon=1 Then AddTriangle(surf,total-one,total-three,total-two)
End Function



Function followroad(gcar.vehic,level)

	
	respot=0
	exdist#=50
	
	Repeat
	
	If KeyHit(1) Then End
	
	gcar\onpiece=gcar\onpiece+1
	
	out=findverts(gcar\onpiece)
	If gcar\onpiece>out
	If gcar\num=playercar
	
		If gcar\lap=totlaps Then newview=9:allcpu=1:endrace=1
	
		timed=MilliSecs()-laptimer
		If timed<record Or gcar\lap=1 Then bestlap=gcar\lap:record=timed
	
		If gcar\lap<=totlaps Then laptime$(gcar\lap)=clocker$(timed)
		laptimer=MilliSecs()
	EndIf
	gcar\onpiece=out
	If gcar\lap<=totlaps Then gcar\lap=gcar\lap+1
	EndIf	
	
	If gcar\num=playercar Then PositionEntity roadpivot,(vx1#+vx2#)/2,(vy1#+vy2#)/2,(vz1#+vz2#)/2
		
	dvx#=(vx1#+vx2#)/2-EntityX(gcar\car)
	dvy#=(vy1#+vy2#)/2-EntityY(gcar\car)
	dvz#=(vz1#+vz2#)/2-EntityZ(gcar\car)
	
	oldexdist#=exdist#
	
	exdist#=(dvx#^2+dvz#^2+0^2)^0.5
	
	resetcar=0
	
	If exdist#>50 Or MilliSecs()-gcar\sunk>500 Then resetcar=1
	If MilliSecs()-gcar\offroad>2000 Then resetcar=1
	
	If gcar\lap>0
	If gcar\speed<0.1 Or carvel#<0.2
	If Abs(gcar\fromcent#)>9 Then resetcar=1
	EndIf
	EndIf
	
	
	If resetcar=1	
	cartoroad(gcar.vehic)
	respot=1
	level=2			
	EndIf
	
		
	roadang#=calc_ang#(vx1#-vx2#,vz1#-vz2#,-90)
	
	theta#=calc_ang#(-dvx#,-dvz#,roadang#)
	If gcar\num=playercar Then gcar\notice#=theta#
		
	Until Abs(theta#)<90
	
	
	;work out left/right position on road
	cmag#=(dvx#^2+dvz#^2)^0.5	
	vxd#=vx1#-vx2#
	vzd#=vz1#-vz2#
	bmag#=(vxd#^2+vzd#^2)^0.5
	bdotc#=dvx#*vxd#+dvz#*vzd#
	costheta#=bdotc#/bmag#/cmag#	
	gcar\fromcent#=cmag#*costheta#
	

	;aim for road piece directly in front, or for one slightly
	;further off (used if car is going to be airborne)
	For lookon=5 To 20
	
	findverts(gcar\onpiece+lookon)
	dvx#=(vx1#+vx2#)/2-EntityX(gcar\car)
	dvy#=(vy1#+vy2#)/2-EntityY(gcar\car)
	dvz#=(vz1#+vz2#)/2-EntityZ(gcar\car)	
	If dvy#>0 Then dvy#=0

	;If Abs(gcar\fromcent#)<5 Then act#=0.3 Else act#=0.5
	act#=0.3

	leap#=(gcar\speed)^2*(Abs(dvy#))*act#
	
	If leap#<lookon Then lookon=20
		
	Next
	
	

	dvx#=(vx1#+vx2#)/2-EntityX(gcar\car)
	dvz#=(vz1#+vz2#)/2-EntityZ(gcar\car)
	
	
	d_ang#=calc_ang#(dvx#,dvz#,EntityYaw(gcar\car))	
		
	gcar\onpiece=gcar\onpiece-1	
		
	If EntityPick(gcar\car,20)<>0 Then gcar\rubble=MilliSecs()
	
	
	gcar\accel#=.005
	;If racestart=1
	If gcar\num<>playercar Or allcpu=1 Or racestart=0 Or respot=1
	
	;d_ang#=d_ang#+20
	If level=1
	gcar\wturn#=gcar\wturn#+d_ang#/2
	d_ang#=d_ang#/10
	If d_ang#>1 Then d_ang#=1
	If d_ang#<-1 Then d_ang#=-1	
	EndIf
	
	If level=2 Then TurnEntity gcar\car,0,d_ang#,0

	
	If gcar\wturn#>30 Then gcar\wturn#=30
	If gcar\wturn#<-30 Then gcar\wturn#=-30
	
	co_left=0:co_right=0:co_rev=0
	
	diff#=Abs(d_ang#)/(Abs(gcar\spturn#)+0.5)
	If gcar\speed*diff#>2 Then co_rev=1
	
	;If onscene=1 Then d_ang#=d_ang#/2
	
	If d_ang#<-(gcar\spturn#*0.2)-0.5 Then co_right=1
	If d_ang#>-(gcar\spturn#*0.2)+0.5 Then co_left=1
	
	If Abs(gcar\speed)*Abs(gcar\spturn#)>0.5 Then co_rev=1
		
	If onscene>0 And gcar\reverse<=50 And racestart=1
	
	
	blocked=0:topb=0
	
	For icar.vehic=Each vehic
	
	If icar\speed<gcar\speed*0.9 ;And gcar\speed>0.5
	If icar\onpiece>=gcar\onpiece And icar\onpiece<=gcar\onpiece+5
	If Abs(gcar\fromcent#-icar\fromcent#)<5
	If blocked=0 Then blocked=1
	If gcar\speed>icar\speed+0.2 Then blocked=2
	
	If blocked>=topb
	If gcar\fromcent#<icar\fromcent# And gcar\fromcent#>0 Then co_left=1:co_right=0
	If gcar\fromcent#>icar\fromcent# And gcar\fromcent#<0 Then co_right=1:co_left=0	
	topb=blocked
	
	EndIf
	
	EndIf
	EndIf
	EndIf	
	Next
	
	
	;If blocked=0 Then co_for=1 Else co_for=0
	;If blocked=2 Then co_rev=1
	co_for=1
	
	agap#=numcars*2000
	
	gcar\accel#=.005+(gcar\place)/agap#
	;If allcpu=0 Then gcar\accel#=gcar\accel#+(numcars-yourplace)/agap#	
	;gcar\accel#=.005
	
	EndIf
	
	EndIf
	
	;co_for=0
	;co_rev=0
	;co_left=0
	;co_right=0

End Function




Function calc_ang#(rya#,ryb#,minus#)
	
	ryc#=ATan#(rya#/ryb#)
	If ryb#<0 Then ryc#=180+ryc#
	ryc#=-ryc#

	res#=ryc#-minus#
	
	If res#<0 Then res#=360-((-res#) Mod 360)
	res#=res# Mod 360
	If res#>180 Then res#=res#-360
		
	Return(res#)
	
End Function



Function findverts(here)

;find road co-ords based on road position 'here'
;here*4 because each road section has 4 vertices

tverts=CountVertices(surface)

If here*4+1>tverts Then here=here+1-tverts/4
	
	vx1#=VertexX(surface,here*4+1)
	vy1#=VertexY(surface,here*4+1)
	vz1#=VertexZ(surface,here*4+1)
	vx2#=VertexX(surface,here*4+2)
	vy2#=VertexY(surface,here*4+2)
	vz2#=VertexZ(surface,here*4+2)
	
Return(here)
	
End Function



Function clocker$(acd)

;acd = millisecs()
;the function turns this into clock form

sw=acd/1000
sx$=Str$(acd Mod 1000)
sy$=Str$(sw/60)
sz$=Str$(sw Mod 60)
While Len(sy$)<2
	sy$="0"+sy$
Wend
While Len(sz$)<2
	sz$="0"+sz$
Wend
While Len(sx$)<3
	sx$="0"+sx$
Wend

trr$=sy$+"'"+sz$+"''"+sx$
Return(trr$)

End Function


Function debugtext(gcar.vehic)
	Color 255,255,255
	;Text 0,0,Int(xspeed#*10)+" mph"
	;Text 0,30,EntityYaw(gcar\car)
	;Text 0,30,EntityPitch(car)
	;Text 0,60,EntityRoll(car)
	;Text 0,90,wturn#
	;Text 0,0,EntityX(gcar\car,True)
	;Text 0,30,EntityZ(gcar\car,True)
	;Text 0,60,playercar
	;Text 0,90,EntityX(gcar\wheels[1])
	;Text 0,110,EntityY(gcar\wheels[1])
	;Text 0,130,EntityZ(gcar\wheels[1])
	;Text 0,200,EntityPitch(gcar\car)
	;Text 0,220,EntityYaw(camera)
	;Text 0,240,EntityRoll(camera)
	;Text 0,270,EntityY(camera)-EntityY(gcar\car)
	Text 250,0,"Frames Per Sec = "+tframs
	;Text 0,330,rrr+"..."+sss
	;Text 0,360,gcar\speed
	;Text 0,120,gcar\place
	;Text 0,150,gcar\maintain
	;Text 0,180,gcar\onpiece
	;Text 0,400,EntityCollided(gcar\car,tarmac);gcar\notice#
	;Text 0,0,EntityPitch(camera);EntityYaw(target)
	;Text 0,0,EntityDistance(camera,target)
	;Text 0,30,sigyaw#
	;Text 0,100,Int(xn#*10)+" "+Int(yn#*10)
	;Text 0,120,colang#
	;Text 0,100,gcar\fromcent#
	;Text 0,200,onscene
	;Text 0,100,EntityY(gcar\car)
	;Text 0,130,MilliSecs()-gcar\sunk
	;Text 0,160,gcar\fromcent#
End Function

Function savescreenshot()   
iFileNumber% = 0  
Repeat  iFileNumber = iFileNumber + 1  
sFileName$ = "motor_shot" + String$("0", 3 - Len(Str$(iFileNumber))) + iFileNumber + ".jpg"  
Until Not(FileType(sFileName))   
SaveBuffer FrontBuffer(), sFileName   
End Function


Function makeplane(extent,detail,texture,ypos#,alpha#)

;could just use createplane for infinite plane
;but this version allows sections to be missed out

plane=CreateMesh()
psurf=CreateSurface(plane)

EntityTexture plane,texture

stretch=extent/detail

For ii=0 To detail
For ij=0 To detail
AddVertex psurf,ii*stretch,0,ij*stretch,(ii Mod 2),(ij Mod 2)

If ii>0 And ij>0
xp=ii*stretch-extent/2-stretch/2
yp=ij*stretch-extent/2-stretch/2

see=1
If Abs(xp)<500 And Abs(yp)<500
If TerrainY(terr,xp,100,yp)>ypos# Then see=0
EndIf

If see=1

cc=CountVertices(psurf)
bl=cc-detail-3
br=cc-detail-2
tl=cc-2
tr=cc-1
AddTriangle psurf,bl,br,tl
AddTriangle psurf,br,tr,tl

EndIf
EndIf

Next
Next

PositionEntity plane,-extent/2,ypos#,-extent/2
EntityAlpha plane,alpha#

End Function



Function newrect(surf,xat#,yat#,zat#,xdx#,ydy#,lx#,ty#,rx#,by#,scape,ang#)

;a rect not attached to other rects
;ang# is used to vary the angle of tree segments

If scape=1 Then ux#=lx#:vx#=rx#:uy#=by#:vy#=ty#
If scape=2 Then ux#=rx#:vx#=lx#:uy#=ty#:vy#=by#

xtx#=xdx#*Cos(ang#)
ztz#=xdx#*Sin(ang#)

AddVertex surf,xat#-xtx#,yat#-ydy#,zat#-ztz#,lx#,by#
AddVertex surf,xat#+xtx#,yat#-ydy#,zat#+ztz#,vx#,uy#
AddVertex surf,xat#-xtx#,yat#+ydy#,zat#-ztz#,ux#,vy#
AddVertex surf,xat#+xtx#,yat#+ydy#,zat#+ztz#,rx#,ty#
total=CountVertices(surf)
newtri(surf,total,1,3,2,1)
newtri(surf,total,2,3,4,1)

End Function




Function keepaway(gcar.vehic)

;simple car collisions system
;stops them from overlapping each other
;views each car as 3 spheres

For icar.vehic = Each vehic

If gcar\num<icar\num
If EntityDistance(gcar\car,icar\car)<10

For gpiv=1 To 3
gx#=EntityX(gcar\pivot[gpiv],True)
gy#=EntityY(gcar\pivot[gpiv],True)
gz#=EntityZ(gcar\pivot[gpiv],True)

For ipiv=1 To 3
ix#=EntityX(icar\pivot[ipiv],True)
iy#=EntityY(icar\pivot[ipiv],True)
iz#=EntityZ(icar\pivot[ipiv],True)

dist#=((ix#-gx#)^2+(iy#-gy#)^2+(iz#-gz#)^2)^0.5

If dist#<3
xacc#=(ix#-gx#)*0.1/dist#
yacc#=(iy#-gy#)*0.1/dist#
zacc#=(iz#-gz#)*0.1/dist#

gcar\transx#=gcar\transx#-xacc#
gcar\transy#=gcar\transy#-yacc#
gcar\transz#=gcar\transz#-zacc#

icar\transx#=icar\transx#+xacc#
icar\transy#=icar\transy#+yacc#
icar\transz#=icar\transz#+zacc#

If gpiv>=ipiv Then gup#=0.05:iup#=0.1
If ipiv>gpiv Then gup#=0.1:iup#=0.05

gcar\speed=gcar\speed+gup#*(gpiv-ipiv)
icar\speed=icar\speed+iup#*(ipiv-gpiv)

EndIf


Next
Next


EndIf
EndIf

Next

End Function


Function MakeSkyBox( file$ )


	m=CreateMesh()
	;front face
	b=LoadBrush( file$+"_FT.bmp",49 )
	s=CreateSurface( m,b )
	AddVertex s,-1,+1,-1,0,0:AddVertex s,+1,+1,-1,1,0
	AddVertex s,+1,-1,-1,1,1:AddVertex s,-1,-1,-1,0,1
	AddTriangle s,0,1,2:AddTriangle s,0,2,3
	FreeBrush b
	;right face
	b=LoadBrush( file$+"_LF.bmp",49 )
	s=CreateSurface( m,b )
	AddVertex s,+1,+1,-1,0,0:AddVertex s,+1,+1,+1,1,0
	AddVertex s,+1,-1,+1,1,1:AddVertex s,+1,-1,-1,0,1
	AddTriangle s,0,1,2:AddTriangle s,0,2,3
	FreeBrush b
	;back face
	b=LoadBrush( file$+"_BK.bmp",49 )
	s=CreateSurface( m,b )
	AddVertex s,+1,+1,+1,0,0:AddVertex s,-1,+1,+1,1,0
	AddVertex s,-1,-1,+1,1,1:AddVertex s,+1,-1,+1,0,1
	AddTriangle s,0,1,2:AddTriangle s,0,2,3
	FreeBrush b
	;left face
	b=LoadBrush( file$+"_RT.bmp",49 )
	s=CreateSurface( m,b )
	AddVertex s,-1,+1,+1,0,0:AddVertex s,-1,+1,-1,1,0
	AddVertex s,-1,-1,-1,1,1:AddVertex s,-1,-1,+1,0,1
	AddTriangle s,0,1,2:AddTriangle s,0,2,3
	FreeBrush b
	;top face
	b=LoadBrush( file$+"_UP.bmp",49 )
	s=CreateSurface( m,b )
	AddVertex s,-1,+1,+1,0,1:AddVertex s,+1,+1,+1,0,0
	AddVertex s,+1,+1,-1,1,0:AddVertex s,-1,+1,-1,1,1
	AddTriangle s,0,1,2:AddTriangle s,0,2,3
	FreeBrush b

	ScaleMesh m,500,500,500
	FlipMesh m
	;EntityFX m,8
	EntityOrder m,1
	Return m
	
	
End Function

Function docollisions()

Collisions BODY,SCENE,2,3
Collisions WHEEL,SCENE,2,3
;Collisions BODY,BODY,3,3
Collisions BODY,TARMAC,2,3
Collisions WHEEL,TARMAC,2,3
Collisions BODY,STRUCT,2,3
;Collisions SCENE,SCENE,2,3

End Function



Function cartoroad(gcar.vehic)

	findverts(gcar\onpiece)

	If gcar\num=playercar Then snapview=1
	
	PositionEntity gcar\car,(vx1#+vx2#)/2,(vy1#+vy2#)/2+5,(vz1#+vz2#)/2
	ResetEntity gcar\car
	
	For dd=1 To 4
	ResetEntity gcar\wheels[dd]
	Next
	
	gcar\lockout=1	
	gcar\speed=0
	gcar\recover=MilliSecs()
	
		
End Function


Function screendata(gcar.vehic)


Color 0,0,0
	Rect 530,0,110,40
	Rect 530,50,110,40
	Rect 530,100,110,40
	
	Color 255,255,255
	SetFont font2
	velo$=Str$(Abs(Int(gcar\speed*200)))
	
	Text 580-StringWidth(velo$),55,velo$
	Text 590,55,"kph"
	
	If gcar\lap<=totlaps Then Text 540,5,"Lap "+gcar\lap+"/"+totlaps
	If gcar\lap>totlaps Then Text 540,5,"Finish"
	
	Text 540,105,"P  "+gcar\place+"/"+numcars
	
	yourplace=gcar\place
	
	SetFont font
	
	For ii=1 To gcar\lap
	
	If ii<=totlaps
	
	Color 0,0,0
	Rect 3,9+ii*18,15,15
	Rect 23,9+ii*18,60,15
	
	Color 255,255,255
	
	Text 6,9+ii*18,ii
	
	If ii=gcar\lap-1 Then Color 255,255,0
	If ii=bestlap Then Color 255,0,0
	If ii=gcar\lap Then laptime$(ii)=clocker$(MilliSecs()-laptimer)
	
	Text 26,10+ii*18,laptime$(ii)
	
	EndIf
	
	Next
	
	
	Color 255,255,255
	Rect 420,5,80,100,False
	
	
	centx#=460:centy#=55
	
	
	Color 255,0,0
	Line centx#,centy#-2,centx#,centy#+2
	
	Color 0,255,0
	
	For icar.vehic = Each vehic
	
	vvx#=EntityX(icar\car)-EntityX(gcar\car)
	vvz#=EntityZ(icar\car)-EntityZ(gcar\car)
	vmag#=(vvx#^2+vvz#^2)^0.5
	vang#=calc_ang#(vvx#,vvz#,carya#)
		
	pxx#=centx#-vmag#*Sin(vang#)
	pyy#=centy#-vmag#*Cos(vang#)
	
	If pxx#>=420 And pxx#<=500 And pyy#>=5 And pyy#<=105
	
	aseen#=EntityYaw(icar\car)-carya#
	Line pxx#-Sin(aseen#)*2,pyy#-Cos(aseen#*2),pxx#+Sin(aseen#)*2,pyy#+Cos(aseen#*2)
	
	EndIf
		
	Next
	
	
End Function